//*          1MHz LED Frequency Counter              *
// This code was written for the free c compiler that comes with MPLAB.
// The 7 segments are at RB0 to RB5,RA3. 
// Each digit is stored in its reg. and converted to 7 segments by preset
// values in digit array.
// TMR2 is set to 4 mS as time base for the clock.
// The display is off for the period of counting.
//
// This code is free to use, for more info   http://www.moty22.co.uk       
   
#include <htc.h>

#define _XTAL_FREQ 4000000

//prototypes
void init(void);
void main(void);
void display(void);

__CONFIG(LVPDIS & MCLRDIS & WDTDIS & UNPROTECT & XT);

bit g;
unsigned char d1,d2,d3;


void init(void){

	CMCON = 0b111;		//comparator off
	T2CON = 0b11101;		//TMR2 prescale=4, postscale=1/4, TMR OFF
	T1CON = 0b100110;        //TMR1 prescale=4, osc=off, counter mode
	PR2 = 249;				//TMR2 period 4ms
	TRISB = 0b11000000;		 //RB 0-5 outputs
	TRISA = 0b11100000;
}
			
void main(void){
	unsigned int total;
	d1=d2=d3=0;
	init();
for(;;){
	TMR2 = 0;
	TMR1L = 0;
	TMR1H = 0;
	TMR1IF = 0;
	TMR2IF = 0;
	
	display();
	TMR2ON = 1;		// start counter
	
		while (!TMR2IF){}		//
		TMR1ON = 1;		// open gate	
		TMR2IF = 0;	
		while (!TMR2IF){}		//
		TMR1ON = 0;		// close gate
		TMR2ON = 0;	
		TMR2IF = 0;	

			//convert 2 bytes to 3 decimal digits
	total=(unsigned int)TMR1L+((unsigned int)TMR1H * 256);
	if(total < 1000){		//display frequency
		d1=(total/100);
		d2=(total/10) %10;
		d3=total %10;
		}else{			//display OF (overflow)
		d1=0;
		d2=10;
		d3=11;}
}		
}
						
void display(void){
	unsigned char i; i=0;	
	unsigned char digit[12];
	digit[0]=0b111111;		//7 segments for 0
	digit[1]=0b110;
	digit[2]=0b1011011;
	digit[3]=0b1001111;
	digit[4]=0b1100110;
	digit[5]=0b1101101;
	digit[6]=0b1111100;
	digit[7]=0b111;
	digit[8]=0b1111111;
	digit[9]=0b1100111;
	digit[10]=0b1110001;		//7 segments for F
	digit[11]=0;				//blank digit
	
	while(i < 120){			//display for a second
		PORTB=digit[d1];
		g=(digit[d1] >> 6); 	//g segmentis on RA3
		RA3=g;
		RA0=1;
		__delay_ms(4);
		RA0=0;
		PORTB=digit[d2];
		g=(digit[d2] >> 6);
		RA3=g;
		RA1=1;
		__delay_ms(4);
		RA1=0;
		PORTB=digit[d3];
		g=(digit[d3] >> 6);
		RA3=g;
		RA2=1;
		__delay_ms(4);
		RA2=0;
		i++;
	}
}	
	